diff --git a/src/hstr_history.c b/src/hstr_history.c
index 4feefca7..74f74a60 100644
--- a/src/hstr_history.c
+++ b/src/hstr_history.c
@@ -228,6 +228,13 @@ int history_mgmt_remove_from_system_history(char *cmd)
         if(offset<historyState->length && !strcmp(cmd, l)) {
             occurences++;
             free_history_entry(remove_history(offset));
+            if(offset>0) {
+                l=historyState->entries[offset-1]->line;
+                if(l && strlen(l) && l[0] == '#') {
+                    // TODO check that this delete doesn't cause mismatch of searched cmd to be deleted
+                    free_history_entry(remove_history(offset-1));
+                }
+            }
         }
         offset=history_search_pos(cmd, 0, ++offset);
     }
diff --git a/tests/resources/.bash_history_BUG_124 b/tests/resources/.bash_history_BUG_124
new file mode 100644
index 00000000..28dfec29
--- /dev/null
+++ b/tests/resources/.bash_history_BUG_124
@@ -0,0 +1,2 @@
+#1234567890
+foobar
diff --git a/tests/resources/.bash_history_BUG_176 b/tests/resources/.bash_history_BUG_176
new file mode 100644
index 00000000..a0d90e03
--- /dev/null
+++ b/tests/resources/.bash_history_BUG_176
@@ -0,0 +1,54 @@
+#1448570565
+history -a
+#1448570586
+ll
+#1448570601
+less a
+#1448570608
+cemacs .bash_history
+#1448570612
+history -a
+#1448570608
+cemacs .bash_history
+#1448570612
+history -a
+#1448570633
+cemacs .bash_history
+#1448570663
+cemacs .bash_history
+#1448571017
+history -a
+#1448571021
+cemacs .bash_history
+#1448571038
+cemacs .bash_history
+#1448571041
+history -a
+#1448571043
+cemacs .bash_history
+#1448571340
+cd p/hstr/github/hstr/
+#1448571341
+ll
+#1448571343
+cd tests/
+#1448571344
+ll
+#1448571358
+cp test_bug124.sh test_bug176.sh
+#1448571364
+cd
+#1448571371
+pop
+#1448570363
+cd
+#1448570370
+less .bash_history
+#1448570512
+man tail
+#1448570529
+tail -n 100 .bash_history 
+#1448570545
+tail -n 50 .bash_history > .bash_history
+#1448570547
+bash
diff --git a/tests/test_bug124.sh b/tests/test_bug124.sh
new file mode 100755
index 00000000..b17981a2
--- /dev/null
+++ b/tests/test_bug124.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+export HH_CONFIG=hicolor
+export HISTFILE=/tmp/hh-bug-124
+
+cp -vf ~/p/hstr/.bash_history_BUG_124 ${HISTFILE}
+
+#cd ~/p/hstr/github/hstr/Debug && gdbserver :9999 ./hh
+#cd ~/p/hstr/github/hstr/Debug && ./hh
+hh
+
+# eof
diff --git a/tests/test_bug176.sh b/tests/test_bug176.sh
new file mode 100755
index 00000000..16b798c4
--- /dev/null
+++ b/tests/test_bug176.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+export HH_CONFIG=hicolor
+export HISTFILE=/tmp/hh-bug-176
+
+cp -vf ~/p/hstr/github/hstr/tests/resources/.bash_history_BUG_176 ${HISTFILE}
+
+#cd ~/p/hstr/github/hstr/Debug && gdbserver :9999 ./hh
+#cd ~/p/hstr/github/hstr/Debug && ./hh
+hh
+
+# eof
